import{PolymerElement,html} from "../../node_modules/@polymer/polymer/polymer-element.js"
import '../../src/shared-styles.js';
import '../../node_modules/@polymer/iron-icon/iron-icon.js'
import '../../node_modules/@vaadin/vaadin-icons/vaadin-icons.js'
import '../../node_modules/@polymer/paper-button/paper-button.js';
import '../../node_modules/@polymer/paper-material/paper-material.js'
import '../../node_modules/@polymer/paper-tooltip/paper-tooltip.js'
import '../../node_modules/@polymer/paper-item/paper-item.js'
import '../../node_modules/@polymer/iron-flex-layout/iron-flex-layout-classes.js'
import '../../node_modules/@vaadin/vaadin-radio-button/vaadin-radio-group.js';
import '../../node_modules/@vaadin/vaadin-grid/vaadin-grid.js';
import '../../node_modules/@vaadin/vaadin-grid/vaadin-grid-filter.js';
/**
 * @customElement
 * @polymer
 */
class ModuleSynoptique extends PolymerElement {
    static get template() {
        return html`
    <style include='iron-flex iron-flex-alignment'></style>
    <style include='shared-styles'>
        .icone {
            color: var(--google-blue-500);
            height: 30px;
            width: 30px;
        }

        .supprimer {
            color: var(--google-red-500);
            height: 30px;
            width: 30px;
            cursor: pointer;
        }

        .modifier {
            color: var(--google-green-500);
            height: 30px;
            width: 30px;
            cursor: pointer;
        }

        .changer {
            color: var(--google-yellow-500);
            height: 30px;
            width: 30px;
            cursor: pointer;
        }

        .nom {
            width: 200px;
        }

        .profil {
            width: 200px;
        }

        .blue {
            color: var(--google-blue-500);
        }

        .red {
            color: var(--google-red-500);
        }

        .boutonPincipal {
            background-color: var(--google-blue-500);
            color: white;
        }

        .center{
          left:50%;
          margin-left: -5%
        }

        .success{
            --paper-toast-background-color: green;
            margin-left:80%;
        }

        .failed{
            --paper-toast-background-color: red;
            margin-left:80%;
        }
    </style>

    <iron-ajax id="ajaxGetList" url="/flybox/controllers/ctrl1/modules/SYNOPTIQUE/ListSvg" method="GET" handle-as="json" on-response="getHandleResponse"
        on-error="handleError"></iron-ajax>
    <iron-ajax id="ajaxPost" url="/flybox/controllers/ctrl1/modules/SYNOPTIQUE/EditSvg" method="POST" handle-as="xml" on-response="postModifyHandleResponse" on-error="handleError"></iron-ajax>
    <iron-ajax id="ajaxGet" url="/flybox/controllers/ctrl1/modules/SYNOPTIQUE/Svg" method="GET" handle-as="json" on-response="getSvgResponse" on-error="handleError"></iron-ajax>
    <iron-ajax id="ajaxDelete" url="/flybox/controllers/ctrl1/modules/SYNOPTIQUE/Svg" method="DELETE" handle-as="json" on-response="postDeleteHandleResponse"></iron-ajax>
    <iron-ajax id="ajaxSetParam" url="/flybox/controllers/ctrl1/modules/SYNOPTIQUE/SetParameter" method="POST" handle-as="json" content-type="application/json"
        on-response="postHandleResponse" on-error="handleError"></iron-ajax>
    <iron-ajax id="ajaxGetParam" url="/flybox/controllers/ctrl1/modules/SYNOPTIQUE/GetParameter" method="GET" handle-as="json" on-response="getResponseModule"
        on-error="handleError"></iron-ajax>

    <vaadin-dialog id="loadDialog" no-close-on-esc no-close-on-outside-click>
        <template>
            <p class="center" style="text-align: center;">Ajout en cours</p>
            <paper-spinner-lite class="center" id="loadSpinner" active></paper-spinner-lite>
        </template>
    </vaadin-dialog>
    <paper-dialog id="dialogErreur">
        <h3 class="red">Erreur</h3>
        <div class="red">
            [[erreur]]
        </div>
        <paper-button dialog-dismiss>fermer</paper-button>
    </paper-dialog>

    <paper-dialog id="dialogConfirmerSupprimer">
        <h3>Supprimer</h3>
        <div class="red">
            Supprimer le svg [[svg.filename]] ?
        </div>
        <paper-button dialog-dismiss class="blue">Annuler</paper-button>
        <paper-button class="blue" on-tap="clickSupprimerOk">ok</paper-button>
    </paper-dialog>

    <paper-dialog id="dialogVoir">
        <h3>Visualiser le svg</h3>
        <div id="svg">
            
        </div>
        <paper-button dialog-dismiss class="blue">Fermer</paper-button>
    </paper-dialog>
    <!-- Vaadin grid + filter -->

    <paper-toast id="requestSuccess" class="success" text="Requête effectuée avec succés"></paper-toast>
    <paper-toast id="requestFailed" class="failed" text="Requête non effectuée"></paper-toast>
        <div class="layout horizontal">
            <paper-button raised class="boutonPincipal" on-tap="rafraichir">Rafraîchir</paper-button>
            <paper-button raised class="boutonPincipal" on-tap="ajouterSvg">Ajouter un svg</paper-button>
            <input id="fileInput" type="file" name="name" style="display: none;" />
            <!--<paper-item>
                    <iron-icon icon="vaadin:clipboard" class="changer" on-tap="changerParam"></iron-icon>
                    <paper-tooltip>Changer les paramétres du module</paper-tooltip>
                </paper-item>-->
        </div>
        <vaadin-grid id="grid" theme="wrap-cell-content" aria-label="Filtering Example" items="[[svgs]]" style="height: 78vh;">
            <vaadin-grid-column width="20%">
                <template class="header">
                    <vaadin-grid-filter aria-label="Nom" path="filename" value="[[_filterName]]">
                        <vaadin-text-field slot="filter" placeholder="Nom" value="{{_filterName}}" focus-target></vaadin-text-field>
                    </vaadin-grid-filter>
                </template>
                <template>[[item.filename]]</template>
            </vaadin-grid-column>

            <vaadin-grid-column width="25%">
                <template class="header">
                    Date de création
                </template>
                <template>[[item.creationTime]]</template>
            </vaadin-grid-column>

            <vaadin-grid-column width="25%">
                <template class="header">Date de derniére modification
                </template>
                <template>[[item.lastWriteTime]]</template>
            </vaadin-grid-column>

            <vaadin-grid-column width="16%">
                <template class="header">
                    Taille du fichier en octets
                </template>
                <template>[[item.sizeFile]]</template>
            </vaadin-grid-column>

            <vaadin-grid-column width="7%">
                <template>
                    <paper-item>
                        <iron-icon icon="vaadin:eye" class="modifier" on-tap="voir"></iron-icon>
                        <paper-tooltip>Visualiser le svg [[item.filename]]</paper-tooltip>
                    </paper-item>
                </template>
            </vaadin-grid-column>

            <vaadin-grid-column width="7%">
                <template>
                    <paper-item>
                        <iron-icon icon="vaadin:close" class="supprimer" on-tap="supprimer"></iron-icon>
                        <paper-tooltip>Supprimer le svg [[item.filename]]</paper-tooltip>
                    </paper-item>
                </template>
            </vaadin-grid-column>

        </vaadin-grid>

    

    `;
    }
    static get properties() {
        return {
            svgs: {
                type: Array
            },
            svg: {
                type: Object
            },
            tagsModified: {
                type: Object
            },
            module: {
                type: Object
            },
            groups: {
                type: Object
            },
            globals: {
                type: Object,
                value : function(){
                  return {};
                },
            }
        };
    }
    connectedCallback() {
        super.connectedCallback();
        this.set("globals", MyAppGlobals);
        setInterval(_ => { this.notifyPath('globals.user.logged'); this.notifyPath('globals.user'); this.notifyPath('globals') }, 500);
        this.$.ajaxGetList.generateRequest();
        this.shadowRoot.querySelector('#fileInput').addEventListener('change', function(e) {this.sendSvgToServer();}.bind(this), false);
    }

    getHandleResponse(req) {
        this.svgs = req.detail.response;
    }
    // Gére les erreurs
    handleError(req) {
        this.erreur = req.detail.error.message;
        if (req.detail.request.xhr.response)
            this.erreur += ". " + req.detail.request.xhr.response;
        this.$.dialogErreur.open();
        this.$.requestFailed.open();
        if(this.$.loadDialog.opened){
            this.$.loadDialog.opened = false;
        }
    }

    voir(e){
        var myNode = this.$.svg;
        while (myNode.firstChild) {
            myNode.removeChild(myNode.firstChild);
        }
        this.svg = e.model.item;
        var parser = new DOMParser();
        var doc = parser.parseFromString(this.svg.content, "image/svg+xml");
        this.$.svg.appendChild(doc.documentElement);
        this.$.dialogVoir.open();
        console.log(this.svg);
        console.log(this.svg.content)
    }

    // Post de la modification de paramétre
    postHandleResponse(req) {
        this.$.dialogChangerParametres.close();
        this.$.requestSuccess.open();
    }

    // Rafraichit la liste des tags
    rafraichir() {
        this.$.ajaxGetList.generateRequest();
    }

    // Permet de simuler un click pour ourir l'explorateur de fichier
    ajouterSvg() {
        this.shadowRoot.querySelector('#fileInput').click();
    }

    // Envoi le fichier svg sélectionné au serveur
    sendSvgToServer(){
        var svg = this.shadowRoot.querySelector('#fileInput').files;
        if(this.shadowRoot.querySelector('#fileInput').value != "" && svg[0].type == "image/svg+xml"){
            var readFile = new FileReader();
            this.done = false;
            readFile.onload = function(event) { this.svg = readFile.result; this.$.ajaxPost.body = this.svg;
                this.$.ajaxPost.set('params', {"title": svg[0].name, "size": svg[0].size});
                if(!this.done){
                    this.$.ajaxPost.generateRequest();
                    this.done = true;
                    this.$.loadDialog.opened = true;
                }
                this.shadowRoot.querySelector('#fileInput').value = ""}.bind(this);
            readFile.readAsText(svg[0]);
        } else {
            this.erreur = "Un probléme est survenu lors de l'ajout du fichier"
            this.$.dialogErreur.open();
            this.$.requestFailed.open();
        }
    }

    postModifyHandleResponse(){
        this.$.loadDialog.opened = false;
        this.$.ajaxGetList.generateRequest();
        this.$.requestSuccess.open();
    }

    // Envoi la requête de suppression
    clickSupprimerOk(){
        this.$.ajaxDelete.body = this.svg.content;
        this.$.ajaxDelete.generateRequest();
    }

    // Retour de la requête de suppression
    postDeleteHandleResponse(req) {
        this.$.dialogConfirmerSupprimer.close();
        this.$.ajaxGetList.generateRequest();
        this.$.requestSuccess.open();
    }

    //Ouvre le dialogue pour supprimer un tag
    supprimer(e) {
        this.svg = e.model.item;
        this.$.dialogConfirmerSupprimer.open();
    }


    getResponseModule(req){
        this.module = req.detail.response;
    }
    // Envoie les modification de paramétres du module au serveur
    clickChangerParamOk() {
        if (this.module.ip != "") {
            this.$.ajaxSetParam.body = {Ip : this.module.ip };
            this.$.ajaxSetParam.generateRequest();
        }
        if (this.module.serverName != "") {
            this.$.ajaxSetParam.body = {ServerName : this.module.serverName };
            this.$.ajaxSetParam.generateRequest();
        }
        if (this.module.protocol != "") {
            this.$.ajaxSetParam.body = {Protocol : this.module.protocol };
            this.$.ajaxSetParam.generateRequest();
        }
        if (this.module.period != "") {
            this.$.ajaxSetParam.body = {Period : this.module.period };
            this.$.ajaxSetParam.generateRequest();
        }
    }

    //Ouvre le dialogue pour changer les paramétres
    changerParam(e) {
        this.$.dialogChangerParametres.open();
    }
}

window.customElements.define('module-synoptique', ModuleSynoptique);
